/**
 * NOTE: This class is auto generated by the swagger code generator program (1.0.11).
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */
package fr.cea.kemanager.dpos.key.restapi;

import java.io.IOException;
import java.util.List;
import java.util.Optional;

import javax.servlet.http.HttpServletRequest;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;

import com.fasterxml.jackson.databind.ObjectMapper;

import fr.cea.kemanager.key.models.KeyObject;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import io.swagger.annotations.ApiResponse;
import io.swagger.annotations.ApiResponses;
@javax.annotation.Generated(value = "io.swagger.codegen.languages.SpringCodegen", date = "2018-03-16T10:57:36.575Z")

@Api(value = "Key", description = "the Key API")
public interface KeyApi {

	Logger log = LoggerFactory.getLogger(KeyApi.class);

    default Optional<ObjectMapper> getObjectMapper() {
        return Optional.empty();
    }

    default Optional<HttpServletRequest> getRequest() {
        return Optional.empty();
    }

    default Optional<String> getAcceptHeader() {
        return getRequest().map(r -> r.getHeader("Accept"));
    }

    @ApiOperation(value = "create key from requestId", nickname = "createKey", notes = "in function of DPOS or FHE component, we start to create a corresponding set of keys", response = String.class, tags={ "key", })
    @ApiResponses(value = { 
        @ApiResponse(code = 200, message = "Server response", response = String.class),
        @ApiResponse(code = 400, message = "Bad request", response = String.class),
        @ApiResponse(code = 404, message = "Not found", response = String.class) })
    @RequestMapping(value = "/dpos/key/create/{requestId}/dsa/{DSAId}",
        produces = { "application/json" }, 
        method = RequestMethod.GET)
    default ResponseEntity<String> createKey(@ApiParam(value = "",required=true) @PathVariable("requestId") String requestId,@ApiParam(value = "",required=true) @PathVariable("DSAId") String dsAId) {
        if(getObjectMapper().isPresent() && getAcceptHeader().isPresent()) {
            if (getAcceptHeader().get().contains("application/json")) {
                try {
                    return new ResponseEntity<>(getObjectMapper().get().readValue("\"\"", String.class), HttpStatus.NOT_IMPLEMENTED);
                } catch (IOException e) {
                    log.error("Couldn't serialize response for content type application/json", e);
                    return new ResponseEntity<>(HttpStatus.INTERNAL_SERVER_ERROR);
                }
            }
        } else {
            log.warn("ObjectMapper or HttpServletRequest not configured in default KeyApi interface so no example is generated");
        }
        return new ResponseEntity<>(HttpStatus.NOT_IMPLEMENTED);
    }


    @ApiOperation(value = "get key from requestId", nickname = "getKey", notes = "in function of DPOS or FHE analytics, we provide a corresponding set of keys", response = KeyObject.class, responseContainer = "List", tags={ "key", })
    @ApiResponses(value = { 
        @ApiResponse(code = 200, message = "Server response", response = KeyObject.class, responseContainer = "List"),
        @ApiResponse(code = 400, message = "Bad request", response = String.class),
        @ApiResponse(code = 404, message = "Not found", response = String.class) })
    @RequestMapping(value = "/dpos/key/get/{requestId}/dsa/{DSAId}",
        produces = { "application/json" }, 
        method = RequestMethod.GET)
    default ResponseEntity<List<KeyObject>> getKey(@ApiParam(value = "",required=true) @PathVariable("requestId") String requestId,@ApiParam(value = "",required=true) @PathVariable("DSAId") String dsAId) {
        if(getObjectMapper().isPresent() && getAcceptHeader().isPresent()) {
            if (getAcceptHeader().get().contains("application/json")) {
                try {
                    return new ResponseEntity<>(getObjectMapper().get().readValue("[ {  \"requestId\" : \"request_id-abcd-xytzssqd\",  \"requestDate\" : \"2017-07-03T22:35:29.771Z\",  \"checksum\" : \"checksum HASH for all the keys\",  \"keyInfo\" : \"public key\",  \"key\" : \"\"}, {  \"requestId\" : \"request_id-abcd-xytzssqd\",  \"requestDate\" : \"2017-07-03T22:35:29.771Z\",  \"checksum\" : \"checksum HASH for all the keys\",  \"keyInfo\" : \"public key\",  \"key\" : \"\"} ]", List.class), HttpStatus.NOT_IMPLEMENTED);
                } catch (IOException e) {
                    log.error("Couldn't serialize response for content type application/json", e);
                    return new ResponseEntity<>(HttpStatus.INTERNAL_SERVER_ERROR);
                }
            }
        } else {
            log.warn("ObjectMapper or HttpServletRequest not configured in default KeyApi interface so no example is generated");
        }
        return new ResponseEntity<>(HttpStatus.NOT_IMPLEMENTED);
    }

}
